# -*- perl -*-
#
# Test::MemMonitor::Snapshot by Daniel Berrange <berrange@redhat.com>
#
# Copyright (C) 2006 Red Hat <http://redhat.com/>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

=pod

=head1 NAME

Test::MemMonitor::Snapshot - XYZ

=head1 SYNOPSIS

  use Test::MemMonitor:Snapshot;



=head1 DESCRIPTION

This module provides....

=head1 METHODS

=over 4

=cut

package Test::MemMonitor::Snapshot;

use Class::MethodMaker [
			scalar => [ qw/ total_size free_size virtual_size resident_size shared_size data_size library_size text_size /,
				    qw/ shared_clean shared_dirty private_clean private_dirty / ],
			new => [ qw/ new / ],
			array => [ qw/ mappings groupings / ],
			];

sub add_grouping {
    my $self = shift;
    my $grouping = shift;

    $self->shared_clean(0) unless defined $self->shared_clean;
    $self->shared_dirty(0) unless defined $self->shared_dirty;
    $self->private_clean(0) unless defined $self->private_clean;
    $self->private_dirty(0) unless defined $self->private_dirty;

    $self->shared_clean($self->shared_clean + $grouping->shared_clean);
    $self->shared_dirty($self->shared_dirty + $grouping->shared_dirty);
    $self->private_clean($self->private_clean + $grouping->private_clean);
    $self->private_dirty($self->private_dirty + $grouping->private_dirty);

    $self->groupings_push($grouping);
}

sub unmapped_size {
    my $self = shift;
    
    return $self->virtual_size - $self->resident_size;
}

sub private_size {
    my $self = shift;
    return $self->resident_size - $self->shared_size;
}

1;

=pod

=back

=head1 AUTHORS

Daniel P. Berrange <berrange@redhat.com>

=head1 LICENSE / COPYRIGHT

Copyright (C) 2006 Red Hat

This software can be distributed under the terms of the GPL v2 or later

=head1 SEE ALSO

=cut

